package com.huimv.cattle.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.FarmStockRank;
import com.huimv.cattle.pojo.SalesCattle;
import com.huimv.cattle.pojo.vo.FarmStockRankVo;
import com.huimv.cattle.service.FarmStockRankService;
import com.huimv.cattle.utils.FarmCodeUtils;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/farmStockRank")
public class FarmStockRankController {

    @Autowired
    private FarmStockRankService farmStockRankService;

    @PostMapping("/saveFarmStockRank")
    @Transactional
    public Result add(@RequestBody FarmStockRankVo farmStockRankVo, HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(farmStockRankVo.getFarmCode(), request);
        List<FarmStockRank> farmStockRanks = farmStockRankVo.getFarmStockRanks();
        farmStockRankService.remove(new QueryWrapper<FarmStockRank>().eq("farm_code",farmCode));
        System.out.println(farmStockRankVo.getFarmCode());
        System.out.println(farmStockRanks.toString());
        for (FarmStockRank farmStockRank : farmStockRanks) {
            farmStockRank.setFarmCode(farmCode);
            farmStockRankService.save(farmStockRank);
        }
        return new Result(10000,"添加成功",true);
    }
    @PostMapping("/updateFarmStockRank")
    public  Result update(@RequestBody FarmStockRank farmStockRank){
        farmStockRankService.updateById(farmStockRank);
        return new Result(10000,"修改成功",true);
    }
    @PostMapping("/deleteFarmStockRank")
    public  Result delete(@RequestBody Map<String,String> paramMap){
        String ids = paramMap.get("ids");
        String[] split = ids.split(",");
        for (String s : split) {
            farmStockRankService.removeById(s);
        }
        return new Result(10000,"删除成功",true);
    }
    @PostMapping("/getFarmStockRank")
    public  Result list(@RequestBody FarmStockRank farmStockRank,HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(farmStockRank.getFarmCode(), request);
        List<FarmStockRank> list = farmStockRankService.list(new QueryWrapper<FarmStockRank>().eq("farm_code",farmCode).orderByDesc("stock"));
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }
}

